;I2C_A.asm
;Output to PCF8574

#include 8051.h
OEA  .equ   7F9Ch
OEB  .equ   7F9Dh
OEC  .equ   7F9Eh
PINSA .equ  7F99h
PINSB .equ  7F9Ah
PINSC .equ  7F9Bh
OUTA .equ   7F96h
OUTB .equ   7F97h
OUTC .equ   7F98h
I2CS  .equ  7FA5h
I2DAT .equ  7FA6h
START .equ  80h
STOP  .equ  40h
LASTRD .equ 20h
ACK   .equ  02h
DONE  .equ  01h

initPortC
     mov DPTR,#OEC
     mov A,#255
     movx @DPTR,A

I2COut
     mov   DPTR,#I2CS
     mov   a,#START
     movx  @DPTR,a
     mov   DPTR,#I2DAT
     mov   a,#40h     ;PCF8574 write
     movx  @DPTR,a
     lcall Ready
     mov   DPTR,#I2DAT
     mov   a,#85      ;data
     movx  @DPTR,a
     lcall Ready
     mov   DPTR,#I2DAT
     mov   a,#85      ;data
     movx  @DPTR,a
     lcall Ready
     mov   DPTR,#I2CS
     mov   a,#STOP
     movx  @DPTR,a
     lcall Ready
     lcall Delay
     sjmp  I2COut

Ready
     mov   DPTR,#I2CS
     movx  a,@DPTR
     mov DPTR,#OUTC
     movx @DPTR,A
     anl   a,#DONE
     cjne  a,#DONE,Ready 
     ret

Delay
     mov   r7,#4
S1   mov   r6,#100
S2   djnz  r6,S2
     djnz  r7,S1   
     ret 




.End
